//Includes
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <winsock2.h>
#include <process.h>
#include <time.h>
#include <usb.h>
#include <errno.h>
#include <unistd.h>

//Typedefs
//typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned int dword;
typedef signed char sbyte;
typedef signed short sword;
typedef signed int sdword;

//Defines
#define handleError(a_arg) {closesocket(server); WSACleanup(); printf(a_arg); system("pause"); return 0;}
#define PUREID_MAGIC  0x08681961
#define PACKET_SIZE 512

//Port
#define PORT 10101

//WSock
CRITICAL_SECTION cs;
byte netListenAlive=1;
byte semaphoreUsb=0x00;
byte semaphoreNet=0x00;
sdword sockSendSize=0;
sdword sockRecvSize=0;
byte sockSend[PACKET_SIZE];
byte sockRecv[PACKET_SIZE];
byte pspSend[PACKET_SIZE+4];
byte pspRecv[PACKET_SIZE+4];
WSADATA wsaData;
SOCKET server;
struct sockaddr_in local;
SOCKET client;
struct sockaddr_in from;

//USB
#define SONY_VID (0x54C)
#define HOSTFSDRIVER_PID  (0x1C9)
int  g_pid = HOSTFSDRIVER_PID;
static usb_dev_handle *g_hDev = NULL;

//Functions
usb_dev_handle *open_device(struct usb_bus *busses)
{
        struct usb_bus *bus = NULL;
        struct usb_dev_handle *hDev = NULL;

        for(bus = busses; bus; bus = bus->next) 
        {
                struct usb_device *dev;

                for(dev = bus->devices; dev; dev = dev->next)
                {
                        if((dev->descriptor.idVendor == SONY_VID) 
                                && (dev->descriptor.idProduct == g_pid))
                        {
                                hDev = usb_open(dev);
                                if(hDev != NULL)
                                {
                                        int ret;
                                        ret = usb_set_configuration(hDev, 1);
                                        
                                        if(ret == 0)
                                        {
                                                ret = usb_claim_interface(hDev, 0);
                                                if(ret == 0)
                                                {
                                                        return hDev;
                                                }
                                                else
                                                {
                                                        usb_close(hDev);
                                                        hDev = NULL;
                                                }
                                        }
                                        else
                                        {
                                                usb_close(hDev);
                                                hDev = NULL;
                                        }
                                }
                        }
                }
        }
        
        if(hDev)
        {
                usb_close(hDev);
        }

        return NULL;
}

usb_dev_handle *wait_for_device(void)
{
  usb_dev_handle *hDev = NULL;

  while(hDev == NULL)
  {
    usb_find_busses();
    usb_find_devices();

    hDev=open_device(usb_get_busses());
    if(hDev)
    {
      printf("PC-->iNET-->PSP-->eNET: Ready\n");
      break;
    }

    /* Sleep for one second */
    sleep(1);
  }

  return hDev;
}

void close_device(struct usb_dev_handle *hDev)
{
  if(hDev)
  {
    usb_release_interface(hDev, 0);
    usb_reset(hDev);
    usb_close(hDev);
  }
}

void usb_kill()
{
  if(g_hDev)
  {
    close_device(g_hDev);
  }
}

void usb_manager()
{
  byte initiated=0x00;
  sdword readLen;
  
  while(1)
  {
    g_hDev=wait_for_device();
    
    if(g_hDev)
    {
      while(1)
      {
        Sleep(0);
        
        //Send
        if(semaphoreNet)
        {
          EnterCriticalSection(&cs);
            printf("PC-->iNET-->PSP-->eNET\n");
            if(g_hDev!=NULL) usb_bulk_write(g_hDev, 0x2, (byte*) &pspSend, PACKET_SIZE+4, 1000);
            semaphoreNet=0;
          LeaveCriticalSection(&cs);
        }
        
        //Read
        if(!semaphoreUsb)
        {
          readLen=usb_bulk_read(g_hDev, 0x81, (byte*) pspRecv, PACKET_SIZE+4, 100);

          //Interpret
          if(readLen == 0)
          {
            printf("PC-->iNET   PSP   eNET: Disconnected\n");
            break;
          }
          else if(readLen == -116/*ETIMEDOUT*/)
          {
            continue;
          }
          else if(readLen < 0)
          {
            break;
          }

          if(readLen == PACKET_SIZE+4)
          {
            EnterCriticalSection(&cs);
              memcpy(sockSend, pspRecv+4, PACKET_SIZE);
              sockSendSize=*((unsigned int*)pspRecv);
              semaphoreUsb=0xFF;
            LeaveCriticalSection(&cs);
            continue;
          }
          else
          {
            printf("Error - Corrupt socket size! - %d\n", readLen);
          }
          
        }
      }
      close_device(g_hDev);
      g_hDev = NULL;
    }
    break;
  }
  
  //Close the client socket
  EnterCriticalSection(&cs);
  closesocket(client);
  client=INVALID_SOCKET;
  LeaveCriticalSection( &cs );
  
  Sleep(2);
}

dword net_init()
{
  memset(&wsaData, 0, sizeof(WSADATA));
  server=0;

  if(WSAStartup(MAKEWORD(2,0), &wsaData) != 0) handleError("PC   iNET: WSAStartup Failed");
  
  local.sin_family=AF_INET; //Address family
  local.sin_addr.s_addr=INADDR_ANY; //Wild card IP address
  local.sin_port=htons((word)PORT); //port to use
  
  server=socket(AF_INET,SOCK_STREAM,0);
  if(server == INVALID_SOCKET) handleError("PC   iNET: Socket Failed");
  
  if(bind(server, (struct sockaddr*)&local, sizeof(local)) != 0) handleError("PC   NET: Bind Failed");

  if(listen(server,10) != 0) handleError("PC   iNET: Listen Failed");
    
  return -1;
}

dword net_kill()
{
  closesocket(server);
  WSACleanup();
  
  return -1;
}

void net_listen()
{
  struct timeval timeVal;
  signed int timeError;
  fd_set setRead;
  fd_set setExcept;
  
    while(1)
    {
      Sleep(0);
      
      //Send data
      if(semaphoreUsb)
      {
        if(sockSendSize == 0)
        {
          printf("CONNECTION RESET BY SERVER\n");
          semaphoreUsb=0;
          break;
        }
        else if(client != -1)
        {
          printf("PC<--iNET<--PSP<--eNET\n");
          sockSendSize=send(client,sockSend,sockSendSize,0);
          if(sockSendSize <= 0)
          {
            printf("CONNECTION RESET BY CLIENT\n");
            
            //Send signal
            *((unsigned int*)pspSend)=0;
            semaphoreNet=0xFF;
            while(semaphoreNet)
            {
              Sleep(0);
            }
            
            //Wait for it to be acknowledged
            while(sockSendSize != 0)
            {
              Sleep(0);
            }
            break;
          }
        }
        semaphoreUsb=0x00;
      }
      
      //Read
      if(!semaphoreNet)
      {
        FD_ZERO(&setRead);
        FD_SET(client, &setRead);
        setExcept=setRead;
        
        timeVal.tv_sec=1;
        timeVal.tv_usec=0;
        timeError=select(FD_SETSIZE, &setRead, NULL, &setExcept, &timeVal);
        if(timeError < 0)
        {
          printf("Error - Select function error\n");
          break;
        }

        if((timeError!=0) && FD_ISSET(client, &setRead))
        { 
          sockRecvSize=recv(client,sockRecv,PACKET_SIZE,0);
          if(sockRecvSize <= 0)
          {
            printf("CONNECTION RESET BY CLIENT\n");
            
            //Send signal
            *((unsigned int*)pspSend)=0;
            semaphoreNet=0xFF;
            while(semaphoreNet)
            {
              Sleep(0);
            }
            
            //Wait for it to be acknowledged
            while(sockSendSize != 0)
            {
              Sleep(0);
            }
            break;
          }  
          else if(sockRecvSize <= PACKET_SIZE)
          { 
            EnterCriticalSection(&cs);
              memcpy(pspSend+4, sockRecv, PACKET_SIZE);
              *((unsigned int*)pspSend)=sockRecvSize;
              semaphoreNet=0xFF;
            LeaveCriticalSection(&cs);
          }
        }
        else
        {
          //printf("umm\n");
          if((timeError!=0) && FD_ISSET(client, &setExcept))
          {
            printf("yup\n");
          }
        } 
      }
    }
}

void net_manager()
{
  dword length=sizeof(struct sockaddr_in);
  client=-1;
  int clientBk=-1;
  
  printf("PC<->iNET: Ready\n");
  _beginthread(usb_manager, 0, NULL);
  
  while(1)
  {
    //Wait for request
    clientBk=accept(server, (struct sockaddr*)&from, &length);
    
    if(clientBk == -1)
    {
      printf("Error - Could not create socket\n");
      Sleep(1);
      continue;
    }
    
    client=clientBk;
    _beginthread(net_listen, 0, NULL);
  }
}

int main()
{
  //PSP Proxy server
  printf("SANiK's PSPRoxy revision A\nBuilt on TyRANiD's USBHostFS\nhttp://sanik.imk.cx/\n\n");
  
  //Init
  InitializeCriticalSection( &cs );
  
  while(!net_init());
  net_manager();

  return -1;
}


