/*
 * PSPLINK
 * -----------------------------------------------------------------------
 * Licensed under the BSD license, see LICENSE in PSPLINK root for details.
 *
 * usbhostfs.h - PSPLINK USB HostFS command header
 *
 * Copyright (c) 2006 James F
 *
 * $HeadURL: file:///home/svn/psp/branches/psplinkusb/usbhostfs/usbCommon.h $
 * $Id: usbhostfs.h 2263 2007-06-28 20:00:22Z tyranid $
 */
#ifndef __USBHOSTFS_H__
#define __USBHOSTFS_H__

#include <stdint.h>

#define DEVCTL_GET_INFO       0x02425818

struct DevctlGetInfo
{
        /* Total number of blocks */
        unsigned int btotal;
        /* Total number of free blocks */
        unsigned int bfree;
        /* Unknown */
        unsigned int unk;
        /* Sector size */
        unsigned int ssize;
        /* Number of sectors per block */
        unsigned int sects;
};

#ifndef PC_SIDE

  #include <pspiofilemgr.h>
  //#define DEBUG 1
  #ifdef DEBUG
    #define DEBUG_PRINTF(fmt, ...)  debugFile=sceIoOpen("ms0:/debug.txt", PSP_O_CREAT | PSP_O_WRONLY | PSP_O_APPEND, 0777); sprintf(debugBuffer, "%s: " fmt, MODULE_NAME, ## __VA_ARGS__); sceIoWrite(debugFile, debugBuffer, strlen(debugBuffer)); sceIoClose(debugFile);
  #else
    #define DEBUG_PRINTF(fmt, ...)
  #endif

  #define MODPRINTF DEBUG_PRINTF

#endif

#endif
